"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Chip: true
};
exports.Chip = void 0;

var _BaseChip = require("./BaseChip");

Object.keys(_BaseChip).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _BaseChip[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _BaseChip[key];
    }
  });
});

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _designparams = require("../designparams");

var _Icon = require("../Icon");

var _Typography = require("../Typography");

var _excluded = ["text", "error", "onRemove", "icon"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ChipIcon = (0, _styledComponents.default)(_Icon.Icon).attrs({
  size: 'small'
}).withConfig({
  displayName: "Chip__ChipIcon",
  componentId: "be8e2k-0"
})(["flex:0 0 min-content;overflow:visible;margin-left:-", ";margin-right:", ";color:", ";"], _designparams.spacing.small, _designparams.spacing.small, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text03();
});
var ChipRemoveIcon = (0, _styledComponents.default)(_Icon.ClickableIcon).attrs({
  tabIndex: 0,
  size: 'small',
  icon: _practicalReactComponentsIcons.CloseIcon
}).withConfig({
  displayName: "Chip__ChipRemoveIcon",
  componentId: "be8e2k-1"
})(["flex:0 0 min-content;overflow:visible;margin-left:", ";"], _designparams.spacing.small);

/* eslint-disable-next-line react/display-name */
var Chip = /*#__PURE__*/_react.default.forwardRef((_ref2, ref) => {
  var {
    text,
    error = false,
    onRemove,
    icon
  } = _ref2,
      props = _objectWithoutProperties(_ref2, _excluded);

  var component = (0, _react.useMemo)(() => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !error && icon !== undefined ? /*#__PURE__*/_react.default.createElement(ChipIcon, {
      icon: icon
    }) : null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
      variant: "chip-tag-text"
    }, text), onRemove ? /*#__PURE__*/_react.default.createElement(ChipRemoveIcon, {
      onClick: onRemove
    }) : null);
  }, [text, error, icon, onRemove]);
  return /*#__PURE__*/_react.default.createElement(_BaseChip.BaseChip, _extends({
    ref: ref,
    error: error,
    component: component
  }, props));
});

exports.Chip = Chip;