"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Droppable = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _theme = require("../theme");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _Icon = require("../Icon");

var _excluded = ["onFileChange", "inputLabel", "supportedFormats", "selectedFileName", "className", "onChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var DroppableIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Droppable__DroppableIcon",
  componentId: "xb4nkp-0"
})(["align-self:center;display:block;color:", ";background-color:", ";padding:", ";border-radius:", ";margin-bottom:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text00();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.elementPrimary();
}, _designparams.spacing.small, _designparams.shape.radius.small, _designparams.spacing.medium);

var DroppableArea = _styledComponents.default.div.withConfig({
  displayName: "Droppable__DroppableArea",
  componentId: "xb4nkp-1"
})(["", " border:1px dashed ", ";display:flex;flex-direction:column;font-size:", ";justify-content:center;text-align:center;padding:", " ", ";cursor:pointer;"], _ref3 => {
  var {
    isDragging
  } = _ref3;
  return isDragging ? (0, _styledComponents.css)(["background-color:", ";"], _ref4 => {
    var {
      theme
    } = _ref4;
    return theme.color.background02();
  }) : undefined;
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.text02();
}, _theme.font.size.small, _designparams.spacing.large, _designparams.spacing.extraLarge);

var DroppableInputFile = _styledComponents.default.input.withConfig({
  displayName: "Droppable__DroppableInputFile",
  componentId: "xb4nkp-2"
})(["display:none;"]);

var DroppableLabel = _styledComponents.default.div.withConfig({
  displayName: "Droppable__DroppableLabel",
  componentId: "xb4nkp-3"
})(["display:grid;grid-gap:", ";grid-template-columns:auto auto;justify-content:center;overflow:hidden;position:relative;color:", ";"], _designparams.spacing.small, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.text01();
});

var InputLabel = (0, _styledComponents.default)(_Typography.Typography).withConfig({
  displayName: "Droppable__InputLabel",
  componentId: "xb4nkp-4"
})(["white-space:initial;word-wrap:break-word;"]);
var enterTarget;

var Droppable = _ref7 => {
  var {
    onFileChange,
    inputLabel,
    supportedFormats,
    selectedFileName,
    className,
    onChange
  } = _ref7,
      props = _objectWithoutProperties(_ref7, _excluded);

  var [isDragging, setDragging] = (0, _react.useState)(false);
  var fileRef = (0, _react.useRef)(null);
  var handleLinkClick = (0, _react.useCallback)(() => {
    var _fileRef$current;

    return (_fileRef$current = fileRef.current) === null || _fileRef$current === void 0 ? void 0 : _fileRef$current.click();
  }, [fileRef]);
  var handleFile = (0, _react.useCallback)(files => {
    if (files === null) {
      return;
    }

    onFileChange === null || onFileChange === void 0 ? void 0 : onFileChange(files[0]);

    if (fileRef.current !== null) {
      fileRef.current.value = '';
    }
  }, [fileRef, onFileChange]);
  var handleDragAndDrop = (0, _react.useCallback)(event => {
    event.preventDefault();

    if (event.type === 'dragenter') {
      enterTarget = event.target;
      setDragging(true);
    }

    if (event.type === 'dragleave' && enterTarget === event.target) {
      event.stopPropagation();
      setDragging(false);
    }

    if (event.type === 'drop') {
      enterTarget = undefined;
      handleFile([...event.dataTransfer.files]);
      setDragging(false);
    }
  }, [handleFile]);
  var handleFileChange = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    handleFile(e.target.files !== null ? [...e.target.files] : null);
  }, [handleFile, onChange]);
  var hasSelectedFile = selectedFileName !== undefined;
  return /*#__PURE__*/_react.default.createElement(DroppableArea, {
    isDragging: isDragging,
    draggable: false,
    onDragEnter: handleDragAndDrop,
    onDragLeave: handleDragAndDrop,
    onDragOver: handleDragAndDrop,
    onDrop: handleDragAndDrop,
    onClick: handleLinkClick,
    className: className
  }, /*#__PURE__*/_react.default.createElement(DroppableIcon, {
    icon: _practicalReactComponentsIcons.DropIcon
  }), /*#__PURE__*/_react.default.createElement(DroppableInputFile, _extends({
    ref: fileRef,
    type: "file",
    multiple: false,
    onChange: handleFileChange
  }, props)), /*#__PURE__*/_react.default.createElement(DroppableLabel, null, /*#__PURE__*/_react.default.createElement(InputLabel, {
    variant: hasSelectedFile ? 'caption' : 'group-title'
  }, inputLabel)), supportedFormats !== undefined && !hasSelectedFile ? /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "caption"
  }, supportedFormats) : null, selectedFileName !== undefined ? /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: !hasSelectedFile ? 'group-title' : 'caption'
  }, selectedFileName) : null);
};

exports.Droppable = Droppable;