import React, { ReactNode } from 'react';
export * from './ArrowIcon';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
interface ExpandableProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * If `true`, the body is expanded.
     * Default `false`
     */
    readonly initialExpanded?: boolean;
    readonly children: {
        readonly header: (expanded: boolean) => ReactNode;
        readonly body: ReactNode;
    };
}
export declare const Expandable: React.FC<ExpandableProps>;
