"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Note = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Typography = require("../Typography");

var _Icon = require("../Icon");

var _designparams = require("../designparams");

var _excluded = ["text", "icon"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var NoteWrapper = _styledComponents.default.div.withConfig({
  displayName: "Note__NoteWrapper",
  componentId: "n4brjn-0"
})(["display:flex;justify-content:flex-start;align-items:center;color:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text03();
});

var NoteIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Note__NoteIcon",
  componentId: "n4brjn-1"
})(["flex:none;align-self:flex-start;color:", ";"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text05();
});

var NoteTextWrapper = _styledComponents.default.div.withConfig({
  displayName: "Note__NoteTextWrapper",
  componentId: "n4brjn-2"
})(["margin-left:", ";"], _designparams.spacing.medium);

var Note = _ref3 => {
  var {
    text,
    icon
  } = _ref3,
      props = _objectWithoutProperties(_ref3, _excluded);

  return /*#__PURE__*/_react.default.createElement(NoteWrapper, props, /*#__PURE__*/_react.default.createElement(NoteIcon, {
    icon: icon
  }), /*#__PURE__*/_react.default.createElement(NoteTextWrapper, null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "default-text"
  }, text)));
};

exports.Note = Note;