"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Paper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _excluded = ["square", "space", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PaperDiv = _styledComponents.default.div.withConfig({
  displayName: "Paper__PaperDiv",
  componentId: "dfgbic-0"
})(["background-color:", ";color:", ";box-shadow:", ";overflow:hidden;", " ", ""], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background00();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text01();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.shadow.knobOn1;
}, _ref4 => {
  var {
    square
  } = _ref4;
  return !square ? (0, _styledComponents.css)(["border-radius:", ";"], _designparams.shape.radius.medium) : undefined;
}, _ref5 => {
  var {
    space
  } = _ref5;
  return space ? (0, _styledComponents.css)(["padding:", " ", ";"], _designparams.spacing.medium, _designparams.spacing.large) : (0, _styledComponents.css)(["padding:0;"]);
});

/* eslint-disable-next-line react/display-name */
var Paper = /*#__PURE__*/(0, _react.forwardRef)((_ref6, ref) => {
  var {
    square = false,
    space = false,
    children
  } = _ref6,
      props = _objectWithoutProperties(_ref6, _excluded);

  return /*#__PURE__*/_react.default.createElement(PaperDiv, _extends({
    square: square,
    space: space
  }, props, {
    ref: ref
  }), children);
});
exports.Paper = Paper;