"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SwitchField = exports.Switch = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _designparams = require("../designparams");

var _utils = require("../utils");

var _Typography = require("../Typography");

var _excluded = ["checked", "disabled", "onChange", "onValueChange", "onFocus", "onPointerUp", "onPointerDown", "label", "className"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SWITCH_THUMB_SIZE = '18px';

var ThumbContainer = _styledComponents.default.div.withConfig({
  displayName: "Switch__ThumbContainer",
  componentId: "u394lc-0"
})(["position:relative;display:inline-flex;align-items:center;justify-content:center;background-color:transparent;width:", ";height:", ";margin:0 -15px;"], SWITCH_THUMB_SIZE, SWITCH_THUMB_SIZE);

var SwitchLabel = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'default-text'
}).withConfig({
  displayName: "Switch__SwitchLabel",
  componentId: "u394lc-1"
})(["margin-right:", ";"], _designparams.spacing.medium);

var ThumbHalo = _styledComponents.default.span.withConfig({
  displayName: "Switch__ThumbHalo",
  componentId: "u394lc-2"
})(["position:absolute;top:0;left:0;width:", ";height:", ";border-radius:", ";background-color:transparent;transition:transform 100ms;"], SWITCH_THUMB_SIZE, SWITCH_THUMB_SIZE, _designparams.shape.radius.circle);

var Thumb = _styledComponents.default.span.withConfig({
  displayName: "Switch__Thumb",
  componentId: "u394lc-3"
})(["box-sizing:border-box;display:block;width:100%;height:100%;border-radius:", ";box-shadow:", ";transition:background-color 200ms ease-in-out;background-color:", ";", ";"], _designparams.shape.radius.circle, _ref => {
  var {
    checked,
    theme
  } = _ref;
  return checked ? theme.shadow.knobOn1 : theme.shadow.knobOff1;
}, _ref2 => {
  var {
    checked,
    theme
  } = _ref2;
  return checked ? theme.color.elementPrimary() : theme.color.element10();
}, _ref3 => {
  var {
    checked,
    theme
  } = _ref3;
  return checked ? undefined : (0, _styledComponents.css)(["border:1px solid ", ";"], theme.color.element16());
});

var Container = _styledComponents.default.div.withConfig({
  displayName: "Switch__Container",
  componentId: "u394lc-4"
})(["display:inline-flex;align-items:center;vertical-align:middle;user-select:none;cursor:default;&:hover{", "{box-shadow:", ";}", "{background-color:", ";transform:scale(1.77);}}&:focus-within{outline:none;", "}&:active{", "{background-color:", ";box-shadow:", ";}", "{background-color:", ";transform:scale(1.88);}}", ";"], Thumb, _ref4 => {
  var {
    checked,
    theme
  } = _ref4;
  return checked ? theme.shadow.knobOn2 : theme.shadow.knobOff1;
}, ThumbHalo, _ref5 => {
  var {
    checked,
    theme
  } = _ref5;
  return checked ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16]);
}, _ref6 => {
  var {
    visibleFocus,
    checked,
    theme
  } = _ref6;
  return visibleFocus ? (0, _styledComponents.css)(["", "{border:2px solid ", ";box-shadow:", ";}", "{background-color:", ";transform:scale(1.77);}"], Thumb, theme.color.textPrimary(), checked ? theme.shadow.knobOn2 : theme.shadow.knobOff1, ThumbHalo, checked ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16])) : undefined;
}, Thumb, _ref7 => {
  var {
    checked,
    theme
  } = _ref7;
  return checked ? theme.color.textPrimary() : undefined;
}, _ref8 => {
  var {
    checked,
    theme
  } = _ref8;
  return checked ? theme.shadow.knobOn3 : theme.shadow.knobOff2;
}, ThumbHalo, _ref9 => {
  var {
    checked,
    theme
  } = _ref9;
  return checked ? theme.color.elementPrimary(_designparams.opacity[24]) : theme.color.element11(_designparams.opacity[24]);
}, _ref10 => {
  var {
    disabled
  } = _ref10;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});

var TapArea = _styledComponents.default.label.withConfig({
  displayName: "Switch__TapArea",
  componentId: "u394lc-5"
})(["position:relative;padding:", ";cursor:", ";"], _designparams.spacing.medium, _ref11 => {
  var {
    disabled
  } = _ref11;
  return disabled ? 'default' : 'pointer';
}); // Visually hidden but covers the whole area to catch user interactions


var NativeCheckbox = _styledComponents.default.input.withConfig({
  displayName: "Switch__NativeCheckbox",
  componentId: "u394lc-6"
})(["position:absolute;top:0;left:0;cursor:pointer;display:unset;margin:0;padding:0;height:100%;width:100%;opacity:0;"]);

var SwitchBox = _styledComponents.default.span.withConfig({
  displayName: "Switch__SwitchBox",
  componentId: "u394lc-7"
})(["display:flex;align-items:center;width:", ";position:relative;"], _designparams.componentSize.small);

var TrackBefore = _styledComponents.default.span.withConfig({
  displayName: "Switch__TrackBefore",
  componentId: "u394lc-8"
})(["display:block;height:14px;border-radius:7px;transition:width 200ms ease-in-out;width:", ";background-color:", ";"], _ref12 => {
  var {
    checked
  } = _ref12;
  return checked ? '30px' : '14px';
}, _ref13 => {
  var {
    theme
  } = _ref13;
  return theme.color.elementHalfPrimary();
});

var TrackAfter = _styledComponents.default.span.withConfig({
  displayName: "Switch__TrackAfter",
  componentId: "u394lc-9"
})(["display:block;height:14px;width:14px;border-radius:7px;flex:auto;background-color:", ";"], _ref14 => {
  var {
    theme
  } = _ref14;
  return theme.color.element14();
});

var Switch = _ref15 => {
  var {
    checked,
    disabled = false,
    onChange,
    onValueChange,
    onFocus,
    onPointerUp,
    onPointerDown,
    label,
    className
  } = _ref15,
      props = _objectWithoutProperties(_ref15, _excluded);

  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleChange = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(e.target.checked);
  }, [onChange, onValueChange]);
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  return /*#__PURE__*/_react.default.createElement(Container, {
    className: className,
    disabled: disabled,
    checked: checked,
    visibleFocus: visibleFocus
  }, label !== undefined ? /*#__PURE__*/_react.default.createElement(SwitchLabel, null, label) : null, /*#__PURE__*/_react.default.createElement(TapArea, {
    disabled: disabled
  }, /*#__PURE__*/_react.default.createElement(SwitchBox, null, /*#__PURE__*/_react.default.createElement(TrackBefore, {
    checked: checked
  }), /*#__PURE__*/_react.default.createElement(ThumbContainer, null, /*#__PURE__*/_react.default.createElement(ThumbHalo, null), /*#__PURE__*/_react.default.createElement(Thumb, {
    checked: checked
  })), /*#__PURE__*/_react.default.createElement(TrackAfter, null)), /*#__PURE__*/_react.default.createElement(NativeCheckbox, _extends({
    type: "checkbox",
    checked: checked,
    disabled: disabled
  }, props, {
    onChange: handleChange,
    onPointerDown: handlePointerDown,
    onPointerUp: handlePointerUp,
    onFocus: handleFocus
  }))));
};

exports.Switch = Switch;
var SwitchField = (0, _utils.withField)(Switch);
exports.SwitchField = SwitchField;